program kefir;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  PFriend = ^TFriend;
  PFriendLink = ^TFriendLink;

  TFriend = record
    Num: integer;
    IsKefir, InitIsKefir: boolean;
    Kefir, Cola, InitFriends: integer;
    FirstKefirFriend: PFriendLink;
  end;

  TFriendLink = record
    Friend: PFriend;
    Next: PFriendLink;
  end;

var
  fi, fo: textfile;
  n: integer;
  pupils: array of PFriend;
  colaHead, colaTail, initColaTail, kefirHead: PFriendLink;
  bestColaCount, bestA, bestB: integer;

  procedure MakeFriends(F1, F2: PFriendLink);
  var
    t: PFriendLink;
  begin
    New(t);
    t^.Friend := F2^.Friend;
    t^.Next := F1^.Friend^.FirstKefirFriend;
    F1^.Friend^.FirstKefirFriend := t;
    Inc(F1^.Friend^.Kefir);

    New(t);
    t^.Friend := F1^.Friend;
    t^.Next := F2^.Friend^.FirstKefirFriend;
    F2^.Friend^.FirstKefirFriend := t;
    Inc(F2^.Friend^.Kefir);
  end;

  procedure CleanUp(F1: PFriendLink = nil; F2: PFriendLink = nil);
  var
    i: integer;
    c, t: PFriendLink;
  begin
    for i := 0 to n - 1 do begin
      with pupils[i]^ do begin
        IsKefir := InitIsKefir;
        Kefir := InitFriends;
        Cola := 0;
      end;
    end;

    if (F1 <> nil) then begin
      t := F1^.Friend^.FirstKefirFriend;
      F1^.Friend^.FirstKefirFriend := t^.Next;
      Dispose(t);
    end;

    if (F2 <> nil) then begin
      t := F2^.Friend^.FirstKefirFriend;
      F2^.Friend^.FirstKefirFriend := t^.Next;
      Dispose(t);
    end;

    c := initColaTail^.Next;
    while (c <> nil) do begin
      t := c^.Next;
      Dispose(c);
      c := t;
    end;
    initColaTail^.Next := nil;
    colaTail := initColaTail;
  end;

  function AreKefirFriends(A, B: PFriendLink): boolean;
  var
    l: PFriendLink;
  begin
    l := A^.Friend^.FirstKefirFriend;
    while (l <> nil) do begin
      if (l^.Friend = B^.Friend) then begin
        Result := true;
        Exit;
      end;
      l := l^.Next;
    end;
    Result := false;
  end;

  function CalculateColaCount: integer;
  var
    c, kf, t: PFriendLink;
  begin
    Result := 0;
    c := colaHead;
    while (c <> nil) do begin
      kf := c^.Friend^.FirstKefirFriend;
      while (kf <> nil) do begin
        with kf^.Friend^ do begin
          if IsKefir then begin
            Dec(Kefir);
            Inc(Cola);
            if (Cola > Kefir) then begin
              IsKefir := false;
              New(t);
              t^.Next := nil;
              t^.Friend := kf^.Friend;
              colaTail^.Next := t;
              colaTail := t;
            end;
          end;
        end;
        kf := kf^.Next;
      end;
      c := c^.Next;
      Inc(Result);
    end;
  end;


var
  i, k, m, a, b, initColaCount, colaCount: integer;
  t: PFriendLink;
  f1, f2: PFriendLink;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  Read(fi, n);
  SetLength(pupils, n);

  colaHead := nil;
  colaTail := nil;
  kefirHead := nil;
  bestA := 0;
  bestB := 0;

  for i := 0 to n - 1 do begin
    Read(fi, k);
    New(pupils[i]);
    FillChar(pupils[i]^, SizeOf(TFriend), 0);
    pupils[i]^.Num := i + 1;
    pupils[i]^.InitIsKefir := (k = 0);

    New(t);
    t^.Friend := pupils[i];
    if (k = 1) then begin
      if (colaTail = nil) then
        colaTail := t;
      t^.Next := colaHead;
      colaHead := t;
    end
    else begin
      t^.Next := kefirHead;
      kefirHead := t;
    end;
  end;
  initColaTail := colaTail;

  Read(fi, m);
  for i := 1 to m do begin
    Read(fi, a, b);
    Dec(a);
    Dec(b);

    Inc(pupils[a]^.InitFriends);
    Inc(pupils[b]^.InitFriends);

    if (pupils[a].InitIsKefir) then begin
      New(t);
      t^.Friend := pupils[a];
      t^.Next := pupils[b]^.FirstKefirFriend;
      pupils[b]^.FirstKefirFriend := t;
    end;

    if (pupils[b].InitIsKefir) then begin
      New(t);
      t^.Friend := pupils[b];
      t^.Next := pupils[a]^.FirstKefirFriend;
      pupils[a]^.FirstKefirFriend := t;
    end;
  end;

  if (colaHead <> nil) then begin
    CleanUp;
    initColaCount := CalculateColaCount;
    bestColaCount := initColaCount;
    CleanUp;

    f1 := kefirHead;
    while (f1 <> nil) do begin
      f2 := kefirHead;
      while (f2 <> nil) do begin
        if (f1 <> f2) and not AreKefirFriends(f1, f2) then begin
          MakeFriends(f1, f2);

          colaCount := CalculateColaCount;
          if (colaCount < bestColaCount) then begin
            bestColaCount := colaCount;
            bestA := f1^.Friend^.Num;
            bestB := f2^.Friend^.Num;
          end;

          CleanUp(f1, f2);
        end;
        f2 := f2^.Next;
      end;
      f1 := f1^.Next;
    end;

    if (bestColaCount < initColaCount) then
      Write(fo, bestA, ' ', bestB)
    else
      Write(fo, -1);
  end
  else
    Write(fo, -1);

  CloseFile(fo);
  CloseFile(fi);
end.
