program kefir_ch;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  PFriend = ^TFriend;
  PFriendLink = ^TFriendLink;

  TFriend = record
    Num: integer;
    IsKefir, InitIsKefir: boolean;
    Kefir, Cola, InitFriends: integer;
    FirstKefirFriend: PFriendLink;
  end;

  TFriendLink = record
    Friend: PFriend;
    Next: PFriendLink;
  end;

var
  n: integer;
  pupils: array of PFriend;
  colaHead, colaTail, initColaTail: PFriendLink;

  procedure MakeFriends(F1, F2: PFriend);
  var
    t: PFriendLink;
  begin
    New(t);
    t^.Friend := F2;
    t^.Next := F1^.FirstKefirFriend;
    F1^.FirstKefirFriend := t;
    Inc(F1^.Kefir);

    New(t);
    t^.Friend := F1;
    t^.Next := F2^.FirstKefirFriend;
    F2^.FirstKefirFriend := t;
    Inc(F2^.Kefir);
  end;

  procedure CleanUp(F1: PFriend = nil; F2: PFriend = nil);
  var
    i: integer;
    c, t: PFriendLink;
  begin
    for i := 0 to n - 1 do begin
      with pupils[i]^ do begin
        IsKefir := InitIsKefir;
        Kefir := InitFriends;
        Cola := 0;
      end;
    end;

    if (F1 <> nil) then begin
      t := F1^.FirstKefirFriend;
      F1^.FirstKefirFriend := t^.Next;
      Dispose(t);
    end;

    if (F2 <> nil) then begin
      t := F2^.FirstKefirFriend;
      F2^.FirstKefirFriend := t^.Next;
      Dispose(t);
    end;

    c := initColaTail^.Next;
    while (c <> nil) do begin
      t := c^.Next;
      Dispose(c);
      c := t;
    end;
    initColaTail^.Next := nil;
    colaTail := initColaTail;
  end;

  function AreKefirFriends(A, B: PFriend): boolean;
  var
    l: PFriendLink;
  begin
    l := A^.FirstKefirFriend;
    while (l <> nil) do begin
      if (l^.Friend = B) then begin
        Result := true;
        Exit;
      end;
      l := l^.Next;
    end;
    Result := false;
  end;

  function CalculateColaCount(const ATag: string; A, B: integer): integer;
  var
    f1, f2: PFriend;
    c, kf, t: PFriendLink;
  begin
    if (A > N) then
      raise Exception.Create(ATag + ': incorrect A');
    if (B > N) then
      raise Exception.Create(ATag + ': incorrect B');
    if (A = B) then
      raise Exception.Create(ATag + ': circular friendship');

    f1 := pupils[A - 1];
    f2 := pupils[B - 1];
    if (not f1^.IsKefir) then
      raise Exception.Create(ATag + ': A doesn''t like kefir');
    if (not f2^.IsKefir) then
      raise Exception.Create(ATag + ': B doesn''t like kefir');

    MakeFriends(f1, f2);
    Result := 0;
    c := colaHead;
    while (c <> nil) do begin
      kf := c^.Friend^.FirstKefirFriend;
      while (kf <> nil) do begin
        with kf^.Friend^ do begin
          if IsKefir then begin
            Dec(Kefir);
            Inc(Cola);
            if (Cola > Kefir) then begin
              IsKefir := false;
              New(t);
              t^.Next := nil;
              t^.Friend := kf^.Friend;
              colaTail^.Next := t;
              colaTail := t;
            end;
          end;
        end;
        kf := kf^.Next;
      end;
      c := c^.Next;
      Inc(Result);
    end;
    CleanUp(f1, f2);
  end;


var
  fin, fout, fans: textfile;
  i, k, m, a, b: integer;
  t: PFriendLink;
  aAns, bAns, aOut, bOut: integer;
  ansColaCount, outColaCount: integer;
begin
  AssignFile(fin, ParamStr(3)); Reset(fin);
  AssignFile(fout, ParamStr(2)); Reset(fout);
  AssignFile(fans, ParamStr(1)); Reset(fans);

  Read(fin, n);
  SetLength(pupils, n);

  colaHead := nil;
  colaTail := nil;

  for i := 0 to n - 1 do begin
    Read(fin, k);
    New(pupils[i]);
    FillChar(pupils[i]^, SizeOf(TFriend), 0);
    pupils[i]^.Num := i + 1;
    pupils[i]^.InitIsKefir := (k = 0);

    if (k = 1) then begin
      New(t);
      t^.Friend := pupils[i];
      if (colaTail = nil) then
        colaTail := t;
      t^.Next := colaHead;
      colaHead := t;
    end;
  end;
  initColaTail := colaTail;

  Read(fin, m);
  for i := 1 to m do begin
    Read(fin, a, b);
    Dec(a);
    Dec(b);

    Inc(pupils[a]^.InitFriends);
    Inc(pupils[b]^.InitFriends);

    if (pupils[a].InitIsKefir) then begin
      New(t);
      t^.Friend := pupils[a];
      t^.Next := pupils[b]^.FirstKefirFriend;
      pupils[b]^.FirstKefirFriend := t;
    end;

    if (pupils[b].InitIsKefir) then begin
      New(t);
      t^.Friend := pupils[b];
      t^.Next := pupils[a]^.FirstKefirFriend;
      pupils[a]^.FirstKefirFriend := t;
    end;
  end;

  Read(fans, aAns);
  Read(fout, aOut);

  if (aAns = -1) xor (aOut = -1) then begin
    WriteLn(
      'ERR: Solution possibility. Answer: ', (aAns <> -1), ', ',
      'solution: ', (aOut <> -1));
    Halt(1);
  end
  else if (aAns = -1) then
    Halt(0);

  if (colaHead <> nil) then begin
    CleanUp;
    Read(fans, bAns);
    Read(fout, bOut);
    ansColaCount := 0;
    outColaCount := 0;
    try
      ansColaCount := CalculateColaCount('Answer', aAns, bAns);
      outColaCount := CalculateColaCount('Out', aOut, bOut);
    except
      on E: Exception do begin
        Writeln(E.Message);
        Halt(1);
      end;
    end;

    if (ansColaCount = outColaCount) then
      Halt(0);
    if (ansColaCount < outColaCount) then begin
      Writeln(
        'Output is worse (answer: ', ansColaCount, ', output: ', outColaCount);
      Halt(1);
    end
    else begin
      Writeln(
        '!!! ANSWER IS WRONG !!! Output is better ',
        '(answer: ', ansColaCount, ', output: ', outColaCount);
      Halt(3);
    end;
  end;

  CloseFile(fin);
  CloseFile(fout);
  CloseFile(fans);
end.
